<script setup>
import { watch } from 'vue'
import { useRouter } from 'vue-router'
import { storeToRefs } from 'pinia'

// Import state management store
import { useInstrumentStore } from '../../stores/instrument.js'

// UI stuff
import { CdxField, CdxTextInput } from '@wikimedia/codex';

// Import composables
import useUtility from '../../composables/utility.js';

const router = useRouter()
const instrumentStore = useInstrumentStore();
const { getSlugFormatted } = useUtility()
const { instrument } = storeToRefs(instrumentStore);

watch(instrument, (newInstrument) => {
    if (newInstrument.name) return
});

// Watch for changes on instrument name to populate formatted slug
watch(
    () => instrumentStore.instrument.name,
    (name) => {
        instrumentStore.instrument.slug = getSlugFormatted(name);
    }
);

/**
 * Get the slug based on instrument id.
 *
 * @param {integer} id
 */
 function getSlug(id) {
    const matchingItem = instrumentStore.instrumentsMenu.find((item) => item.value === id);
    return matchingItem ? matchingItem.slug : '';
}

/**
 * Prepopulate form on input.
 *
 * @param {string} value
 */
function onSelection( value ) {
    // router.push({ params: { slug: getSlug(value) } });
    const newSlug = getSlug(value)
    if (instrumentStore.isModifyFunction) {
        router.push('/update-instrument/' + newSlug)
    } else {
        instrumentStore.setInstrument(newSlug)
    }
}

function capitalizeFirstLetter( string ) {
  return [...string][0].toUpperCase() + [...string].slice(1).join('')
}

function lowercaseFirstLetter( string ) {
  return [...string][0].toLowerCase() + [...string].slice(1).join('')
}

</script>

<template>
    <h2>Name</h2>
    <br>
    <!-- GET STARTED: Instrument and Machine-readable name -->
    <div>
        <div class="column human-name-new" v-if="instrumentStore.isNewFunction">
            <cdx-field>
                <cdx-text-input
                    v-model="instrumentStore.instrument.name"
                    data-id="instrument-name-new"
                />
                <template #label>
                    {{ capitalizeFirstLetter( instrumentStore.instrument.type ) }} name
                </template>
                <template #description>
                    Add the name of the {{ instrumentStore.instrument.type }}, as documented in the measurement plan.<br />This cannot be modified later.
                </template>
            </cdx-field>
        </div>
        <div v-if="instrumentStore.isModifyFunction" :class="{
                'column': true,
                'human-name-modify-instrument': !instrumentStore.isABTest
            }">
            <cdx-field>
                <cdx-text-input
                    v-model="instrumentStore.instrument.name"
                    aria-label="Existing instrument"
                    @update:selected="onSelection"
                    :readonly="instrumentStore.isActivated"
                    data-id="instrument-name-modify"
                    v-tooltip="instrumentStore.activatedTooltip"
                ></cdx-text-input>
                <template #label v-if="instrumentStore.isABTest">
                    Existing {{ instrumentStore.instrument.type }}
                </template>
                <template #label v-else>
                    Existing {{ lowercaseFirstLetter( instrumentStore.instrument.type ) }}
                </template>
                <template #description>
                    Choose an existing {{ instrumentStore.instrument.type }} to edit.
                </template>
            </cdx-field>
        </div>
        <div :class="{
                'column': true,
                'right': true,
                'human-name-modify-abtest-right': instrumentStore.isABTest && instrumentStore.isModifyFunction,
                'human-name-modify-instrument-right': !instrumentStore.isABTest && instrumentStore.isModifyFunction,
            }">
            <cdx-field>
                <cdx-text-input
                    v-model="instrumentStore.instrument.slug" :readonly="true"
                    data-id="instrument-slug"
                />
                <template #label>
                    Machine-readable name
                </template>
                <template #description>
                    Auto-generated name required by the system. <br />This cannot be edited.
                </template>
            </cdx-field>
        </div>
    </div>
    <div class="clearfix"></div>
</template>

<style scoped>
.sectiontitle {
    width: 100%;
}
.cdx-field {
    width: 300px;
}
.column {
    width: 300px;
}
</style>
